unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, RegistryEnhanced, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    KeysListBox: TListBox;
    GetSubKeysButton: TButton;
    GetValueNamesButton: TButton;
    KeyEdit:     TEdit;
    DeleteValueButton: TButton;
    DeleteKeyButton: TButton;
    RegistryEnhanced1: TRegistryEnhanced;
    QuitButton:  TButton;
    SearchListBox: TListBox;
    SearchButton: TButton;
    Label2:      TLabel;
    RootKeyComboBox: TComboBox;
    ClearSpeedButton: TSpeedButton;
    ExportButton: TButton;
    SaveDialog1: TSaveDialog;
    Label1:      TLabel;
    ValuesListBox: TListBox;
    Label3:      TLabel;
    Label4:      TLabel;
    Label5:      TLabel;
    Label6:      TLabel;
    SearchOptionRadioGroup: TRadioGroup;
    RecursiveCheckBox: TCheckBox;
    SearchEdit:  TEdit;
    procedure GetSubKeysButtonClick(Sender: TObject);
    procedure GetValueNamesButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure KeyEditChange(Sender: TObject);
    procedure DeleteValueButtonClick(Sender: TObject);
    procedure KeysListBoxDblClick(Sender: TObject);
    procedure DeleteKeyButtonClick(Sender: TObject);
    procedure QuitButtonClick(Sender: TObject);
    procedure SearchButtonClick(Sender: TObject);
    procedure RootKeyComboBoxChange(Sender: TObject);
    procedure ClearSpeedButtonClick(Sender: TObject);
    procedure ExportButtonClick(Sender: TObject);
    procedure KeysListBoxClick(Sender: TObject);
    procedure ValuesListBoxClick(Sender: TObject);
    procedure SearchListBoxClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.GetSubKeysButtonClick(Sender: TObject);
begin
  RegistryEnhanced1.GetSubKeys('', KeysListBox.items);
end;

procedure TForm1.GetValueNamesButtonClick(Sender: TObject);
begin
  RegistryEnhanced1.GetValueNames('', ValuesListBox.items);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // Update the RootKey comboBox
  if RegistryEnhanced1.RootKey = hkClassesRoot then
    RootKeyComboBox.Text := 'hkClassesRoot';
  if RegistryEnhanced1.RootKey = hkCurrentConfig then
    RootKeyComboBox.Text := 'hkCurrentConfig';
  if RegistryEnhanced1.RootKey = hkCurrentUser then
    RootKeyComboBox.Text := 'hkCurrentUser';
  if RegistryEnhanced1.RootKey = hkDynData then
    RootKeyComboBox.Text := 'hkDynData';
  if RegistryEnhanced1.RootKey = hkLocalMachine then
    RootKeyComboBox.Text := 'hkLocalMachine';
  if RegistryEnhanced1.RootKey = hkUsers then
    RootKeyComboBox.Text := 'hkUsers';
  // Update the Key editbox
  KeyEdit.Text := RegistryEnhanced1.Key;
end;

procedure TForm1.KeyEditChange(Sender: TObject);
begin
  RegistryEnhanced1.Key := KeyEdit.Text;
end;

procedure TForm1.DeleteValueButtonClick(Sender: TObject);
begin
  if (ValuesListBox.ItemIndex > -1) then
  begin
    RegistryEnhanced1.DeleteValue(ValuesListBox.items[ValuesListBox.ItemIndex]);
    ValuesListBox.items.Delete(ValuesListBox.ItemIndex);
  end;

end;

procedure TForm1.KeysListBoxDblClick(Sender: TObject);
begin
  KeyEdit.Text := KeyEdit.Text + '\' + KeysListBox.items[KeysListBox.ItemIndex];
  GetSubKeysButton.click;
  GetValueNamesButton.click;
end;

procedure TForm1.DeleteKeyButtonClick(Sender: TObject);
begin
  if (KeysListBox.ItemIndex > -1) then
  begin
    RegistryEnhanced1.DeleteKey(KeysListBox.items[KeysListBox.ItemIndex]);
    KeysListBox.items.Delete(KeysListBox.ItemIndex);
  end;
end;

procedure TForm1.QuitButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.SearchButtonClick(Sender: TObject);
begin
  SearchListBox.Clear;
  SearchListBox.Hint := '';
  case SearchOptionRadioGroup.ItemIndex of
    0: RegistryEnhanced1.search('', SearchEdit.Text, opValue, RecursiveCheckBox.Checked);
    1: RegistryEnhanced1.search('', SearchEdit.Text, opData, RecursiveCheckBox.Checked);
    2: RegistryEnhanced1.search('', SearchEdit.Text, opValueData,
        RecursiveCheckBox.Checked);
    3: RegistryEnhanced1.search('', SearchEdit.Text, opKey, RecursiveCheckBox.Checked);
  end;
  SearchListBox.items.Assign(RegistryEnhanced1.EntriesFound);
  Label2.Caption := IntToStr(SearchListBox.items.Count) + ' item(s) found.';
end;

procedure TForm1.RootKeyComboBoxChange(Sender: TObject);
begin
  // Update RootKey combobox
  if RootKeyComboBox.Text = 'hkClassesRoot' then
    RegistryEnhanced1.RootKey := hkClassesRoot;
  if RootKeyComboBox.Text = 'hkCurrentConfig' then
    RegistryEnhanced1.RootKey := hkCurrentConfig;
  if RootKeyComboBox.Text = 'hkCurrentUser' then
    RegistryEnhanced1.RootKey := hkCurrentUser;
  if RootKeyComboBox.Text = 'hkDynData' then
    RegistryEnhanced1.RootKey := hkDynData;
  if RootKeyComboBox.Text = 'hkLocalMachine' then
    RegistryEnhanced1.RootKey := hkLocalMachine;
  if RootKeyComboBox.Text = 'hkUsers' then
    RegistryEnhanced1.RootKey := hkUsers;
end;

procedure TForm1.ClearSpeedButtonClick(Sender: TObject);
begin
  KeyEdit.Text := '';
end;

procedure TForm1.ExportButtonClick(Sender: TObject);
begin
  // Export the registry
  SaveDialog1.InitialDir := extractFilePath(application.exename);
  SaveDialog1.FileName   := '';
  if (SaveDialog1.Execute = True) then
    RegistryEnhanced1.SaveKeyContentToFile('', SaveDialog1.FileName, '~');
end;

procedure TForm1.KeysListBoxClick(Sender: TObject);
begin
  if (KeysListBox.ItemIndex > -1) then
    DeleteKeyButton.Enabled := True
  else
    DeleteKeyButton.Enabled := False;
end;

procedure TForm1.ValuesListBoxClick(Sender: TObject);
begin
  if (ValuesListBox.ItemIndex > -1) then
    DeleteValueButton.Enabled := True
  else
    DeleteValueButton.Enabled := False;
end;

procedure TForm1.SearchListBoxClick(Sender: TObject);
begin
  SearchListBox.Hint := SearchListBox.items[SearchListBox.ItemIndex];
end;

end.

